Attribute VB_Name = "dhSQLtoTable"
'    Verweise
'    Microsoft ActiveX Data Objects 2.8 Library
'    Microsoft ActiveX Data Objects Recordset 6.0 Library
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Dim i As Integer
Dim form() As Variant
Dim prozent() As Variant
Const picPath = "C:\Temp\Bild.jpeg"
Const picScale = 70

Public Sub tableFromSQL()
        
    form = Array("", "", "dd.mm.yyyy;r", "#,##0.00 ;r")
    prozent = Array(12, 48, 20, 20)
    i = SQLDataToWordTable(11, 1, "Data Source=meinnPC\SQLEXPRESS;Database=Buchhaltung" _
        + ";Integrated Security=SSPI;DataTypeCompatibility=80;", _
        "SELECT TOP 20 Kategorie, Buchungstext, Datum, Wert FROM Buchungen WHERE Jahr=2011 ORDER BY Datum", _
        True, "Buchungen", form, prozent)

End Sub

' Lesen von SQL-Datenbanktabelle und schreiben in Word-Tabelle
' art:      Art der Speicherung(11.. new table, 12.. update table, 21.. array)
' connStr:  Connectionstring
' selStr:   SELECT-String
' ueber:    Tabelle mit berschrift oder nicht
' Titel:    Titel (1. Zeile berschrift) der Tabelle, wenn ueber=True
' formats:  Feld mit Formatierungsparametern
' prozW:    String mit den prozentualen Spaltenbreiten der Tabelle
Public Function SQLDataToWordTable( _
    art As Integer, _
    tbn As Integer, _
    connStr As String, _
    selStr As String, _
    Optional ueber As Boolean, _
    Optional Titel As String, _
    Optional formats As Variant, _
    Optional prozW As Variant) As Variant
    
    Dim j As Integer, i As Integer, v As Variant
    Dim sp() As String, rtf As Boolean, img As Boolean, bild() As Byte
    Dim table As Range, cellT As Range
    
    ' erstellen eines Connection-Objekts
    Dim cnData As ADODB.Connection
    Set cnData = New ADODB.Connection
    Dim strConn As String
    ' verwenden des SQL-Server-OLEDB-Provider mit dem Connection-String
    ' (in diesem Fall der Provider fr Office 2007!)
    strConn = "PROVIDER=SQLNCLI11;" & connStr
    ' ffnen der Connection
    cnData.ConnectionString = strConn
    cnData.Open
    
' Verwendung der Datenbank-Struktur
'    Dim scheme() As String
'    Dim schemaT As ADODB.Recordset
'    Set schemaT = cnData.OpenSchema(adSchemaColumns, Array(Empty, Empty, "Buchungen"))
'    i = 0
'    ReDim scheme(i)
'    While Not schemaT.EOF
'        scheme(i) = schemaT!COLUMN_NAME
'        Debug.Print scheme(i)
'        i = i + 1
'        ReDim Preserve scheme(i)
'        schemaT.MoveNext
'    Wend
    
    ' erstellen eines Recordset
    Dim rsData As ADODB.Recordset
    Set rsData = New ADODB.Recordset
    
    ' erstellen eines Stream-Objekts
    Dim strStream As ADODB.Stream
    Set strStream = New ADODB.Stream
    strStream.Type = adTypeBinary
    
    With rsData
        ' bereitstellen der Datenstze
        .Open selStr, cnData, adOpenStatic, adLockOptimistic
        Select Case art
            Case 11, 12   ' in neue Word-Tabelle oder Update
                ' kopieren der Datenstze in die Tabellenzellen
                Dim cols As Integer, zeil As Integer
                cols = .Fields.Count    ' Spaltenanzahl
                zeil = .RecordCount     ' Zeilenanzahl
                If ueber = True Then zeil = zeil + 2    ' mit 2 berschriften-Zeilen
                If art = 11 Then        'neue Tabelle
                    Set table = CreateTable(cols, zeil, prozW)
                    If ueber = True Then
                        ' 1.berschrift: Titel in verbundene Zelle
                        ActiveDocument.Tables(WhichTableNumber).cell(1, 1).Merge _
                                MergeTo:=ActiveDocument.Tables(WhichTableNumber).cell(1, cols)
                        ActiveDocument.Tables(WhichTableNumber).cell(1, 1).Range.text = Titel
                        Set table = ActiveDocument.Tables(WhichTableNumber).Range
                    End If
                ElseIf art = 12 Then    ' Update Tabelle
                    Dim tcols As Integer, tzeil As Integer, diff As Integer
                    Set table = ActiveDocument.Tables(WhichTableNumber).Range
                    ' aktuelle Tabellenparameter
                    tcols = table.columns.Count
                    tzeil = table.Rows.Count
                    diff = tzeil - zeil
                    If tcols <> cols Then Exit Function ' beenden, wenn Spaltenanzahlen bei Update nicht gleich
                    With selection
                        .EndOf unit:=wdTable
                        If diff < 0 Then      ' mehr Zeilen
                            .InsertRowsBelow Abs(diff)
                            .StartOf unit:=wdTable
                        ElseIf diff > 0 Then  ' weniger Zeilen
                            For j = 1 To diff
                                .SelectRow
                                .Rows.Delete
                                .EndOf unit:=wdTable
                            Next
                        End If
                        Set table = ActiveDocument.Tables(WhichTableNumber).Range
                        .StartOf unit:=wdTable ' Cursor an Tabellenanfang
                    End With
                End If
                ' Tabelle mit Daten ausfllen
                If ueber Then j = 1 Else j = 0  ' mit berschriften oder nicht
                Do
                    selection.Collapse (wdCollapseStart)    ' Cursor an Anfang setzen
                    For i = 0 To cols - 1
                        If ueber = True And j = 1 Then
                            v = .Fields(i).Name     ' Feldnamen in berschriftszeile 2
                        Else
                            v = .Fields(i).Value    ' Datenfeldwerte
                        End If
                        Set cellT = table.Rows(j + 1).Cells(i + 1).Range    ' aktuelle Tabellenzelle setzen
                        If ueber And j = 1 Then borderColor table.Rows(j + 1).Range, wdColorSeaGreen
                        If Not IsMissing(formats) Then  ' ist Formatierungsfeld angegeben?
                            sp = Split(formats(i), ";") ' Formatierungsparameter
                            If UBound(sp) > 0 Then
                                If sp(0) <> "" Then ' Zahlen/Datums/RTF-Format
                                    rtf = (sp(0) = "RTF" And j > 1)
                                    img = (sp(0) = "IMG" And j > 1)
                                    If rtf Then
                                        copyV CStr(v)
                                    ElseIf img Then
                                        If Not IsNull(.Fields(i).Value) Then
                                            With strStream
                                                .Open
                                                .Write rsData.Fields(i)
                                                .SaveToFile picPath, adSaveCreateOverWrite
                                                .Close
                                            End With
                                        End If
                                    Else
                                        v = Format(v, sp(0))
                                    End If
                                End If
                                If sp(1) <> "" Then ' Alignment fr Tabellenzelle
                                    Select Case sp(1)
                                        Case "r"
                                            cellT.Paragraphs.Alignment = wdAlignParagraphRight
                                       Case "c"
                                            cellT.Paragraphs.Alignment = wdAlignParagraphCenter
                                    End Select
                                End If
                            End If
                        End If
                        If IsNull(v) Then v = "Null"    ' ist Datenwert = NULL?
                        If rtf Then             ' RTF-Daten?
                            cellT.paste
                            rtf = False
                        ElseIf img Then
                            table.Rows(j + 1).Cells(i + 1).Select
                            Dim shp As InlineShape, r As Range
                            Set r = ActiveDocument.Tables(WhichTableNumber).cell(j + 1, i + 1).Range
                            r.Select: selection.Collapse
                            Set shp = selection.InlineShapes.AddPicture( _
                                fileName:=picPath, _
                                LinkToFile:=False, _
                                SaveWithDocument:=True)
                                picScalingW shp, picScale
                            img = False
                        Else
                            cellT.text = v      ' Datenfeldwert in Zelle speichern
                        End If
                    Next
                    If ueber = True Then
                        If j > 1 Then .MoveNext ' Move nur, wenn nicht berschriftszeile
                    Else
                        .MoveNext
                    End If
                    j = j + 1
                    DoEvents
                Loop While .EOF = False
                SQLDataToWordTable = 0  ' Rckgabe von 0, wenn Erstellung oder Update einer Tabelle
            Case 21     ' speichern der Daten in Array
                ' kopieren von Daten in ein Array (nur ein Datenfeld!)
                Dim tmpFeld() As String
                ReDim tmpFeld(.RecordCount)
                j = 0
                Do
                    tmpFeld(j) = .Fields(0)
                    .MoveNext
                    j = j + 1
                Loop While .EOF = False
                SQLDataToWordTable = tmpFeld    ' Rckgabe eines Feldes, wenn Feld erzeugt
        End Select
        If art <> 21 Then MsgBox CStr(rsData.RecordCount) & " Datenstze eingetragen."
        .Close
    End With
    cnData.Close
    Set rsData = Nothing
    Set cnData = Nothing
    selection.StartOf unit:=wdTable
    ActiveDocument.Windows(1).ScrollIntoView selection.Range, True
End Function

' Kopieren von RTF-Daten in Zwischenablage
Sub copyV(sRTF As String)
    'Instantiate a vbaClipboard object
    Dim myClipboard As New vbaClipBoard
    'The ClipboardFormat class encapsulates a clipboard format number and a name
    Dim clipboardFormat As clipboardFormat
    myClipboard.SetClipboardText sRTF, "Rich Text Format"
End Sub

'Border eines Range frben
's: das Range
'c: die Farbe
Sub borderColor(s As Range, c As WdColor)
    With s.Borders(wdBorderBottom)
        .LineStyle = wdLineStyleSingle
        .LineWidth = wdLineWidth150pt
        .Color = c
    End With
End Sub

'Einfgen eines Bildes in Word-Tabelle
Sub picScalingW(iss As InlineShape, w As Integer)
'http://software-solutions-online.com/2014/05/30/word-vba-resize-pictures/
    Dim objDocument As Document
    Dim lngPercent2Scale As Long, lngOriginalWidth As Long, lngScaledWidth As Long
    Application.ScreenUpdating = False
    iss.LockAspectRatio = msoTrue
    'percent to resize
    lngPercent2Scale = w
    Set objDocument = Documents.Add
    iss.Select
    selection.Copy
    objDocument.Activate
    selection.paste
    With ActiveDocument.InlineShapes.Item(1)
        'the width of the scaled image
        lngScaledWidth = .Width
        'rescale to original size
        .ScaleWidth = 100
        'the size of the original image
        lngOriginalWidth = .Width
    End With
    'close document
    objDocument.Close (False)
    'resize
    iss.ScaleWidth = lngPercent2Scale * lngScaledWidth / lngOriginalWidth
End Sub

Sub picScalingH(iss As InlineShape, h As Integer)
    Dim objDocument As Document
    Dim lngPercent2Scale As Long, lngOriginalHeight As Long, lngScaledHeight As Long
    'percent to resize
    lngPercent2Scale = h
    Set objDocument = Documents.Add
    iss.Select
    selection.Copy
    objDocument.Activate
    selection.paste
    With ActiveDocument.InlineShapes.Item(1)
        'the height of the scaled image
        lngScaledHeight = .Height
        'rescale to original size
        .ScaleHeight = 100
        'the size of the original image
        lngOriginalHeight = .Height
    End With
    'close document
    objDocument.Close (False)
    'resize
    iss.ScaleHeight = lngPercent2Scale * lngScaledHeight / lngOriginalHeight
End Sub

